// subor ModelSwarm.java

import swarm.Globals;
import swarm.Selector;
import swarm.defobj.Zone;
import swarm.defobj.SymbolImpl;

import swarm.defobj.FArguments;
import swarm.defobj.FArgumentsImpl;
import swarm.defobj.FCall;
import swarm.defobj.FCallImpl;

import swarm.activity.Activity;
import swarm.activity.ActionGroup;
import swarm.activity.ActionGroupImpl;
import swarm.activity.Schedule;
import swarm.activity.ScheduleImpl;
import swarm.activity.FActionForEach;

import swarm.objectbase.Swarm;
import swarm.objectbase.SwarmImpl;
import swarm.objectbase.VarProbe;
import swarm.objectbase.MessageProbe;
import swarm.objectbase.EmptyProbeMapImpl;

import java.util.LinkedList;
import java.util.List;

import swarm.space.Grid2d;
import swarm.space.Grid2dImpl;

public final class ModelSwarm extends SwarmImpl
{
	private static int worldXSize, worldYSize;
	private static double seedProb;
	private static double bugDensity;
	
	private static FoodSpace food;
	private static Grid2d world;
	
	private static LinkedList bugList;
	private static ActionGroup modelActions;
	private static Schedule modelSchedule;
	
	FActionForEach actionForEach;    // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
	public ModelSwarm(Zone aZone)    // createBegin()
	{
		super(aZone);
		
		worldXSize = 80;
		worldYSize = 80;
		seedProb = 0.5;
		bugDensity = 0.1;
	}
	
	public List getBugList()
	{
		return bugList;
	}
	
	public Grid2d getWorld()
	{
		return world;
	}
	
	public FoodSpace getFood()
	{
		return food;
	}
	
	public Object createObjects()
	{
		Bug aBug;
		int x, y;
		
		food = new FoodSpace(worldXSize, worldYSize);
		food.seedFoodWithProb(seedProb);
		
		world = new Grid2dImpl();
		// world.setSizeX$Y(worldXSize, worldYSize);
		world.fillWithObject(null);
		
		bugList = new LinkedList();
		for(y = 0; y < worldYSize; y++)
			for(x = 0; x < worldXSize; x++)
				if(Math.random() < bugDensity)
				{
					aBug = new Bug();
					aBug.setWorld$Food(world, food);
					aBug.createEnd();
					aBug.setX$Y(x, y);
					
					bugList.addLast(aBug);
				}
		
		return this;
	}
	
	
	public Object buildActions()
	{
		modelActions = new ActionGroupImpl();
		try
		{
			modelActions.createActionForEach$message(bugList, new Selector(bugList.getClass(), "step", false)); 
		}
		catch(Exception e)
		{
		}
		modelSchedule = new ScheduleImpl();
		modelSchedule.setRepeatInterval(1);
		modelSchedule.at$createAction(0, modelActions);
		
		return this;
	}
	
	
	public Activity activateIn(Swarm swarmContext)
	{
		super.activateIn(swarmContext);
		modelSchedule.activateIn(this);
				
		return this.getActivity();
	}

}

