// subor ObserverSwarm.java

import swarm.Globals;
import swarm.Selector;
import swarm.defobj.Zone;

import swarm.activity.Activity;
import swarm.activity.ActionGroup;
import swarm.activity.ActionGroupImpl;
import swarm.activity.Schedule;
import swarm.activity.ScheduleImpl;

import swarm.objectbase.Swarm;
import swarm.objectbase.VarProbe;
import swarm.objectbase.MessageProbe;
import swarm.objectbase.EmptyProbeMapImpl;

import swarm.gui.Colormap;
import swarm.gui.ColormapImpl;
import swarm.gui.ZoomRaster;
import swarm.gui.ZoomRasterImpl;

import swarm.analysis.EZGraph;
import swarm.analysis.EZGraphImpl;

import swarm.simtoolsgui.GUISwarm;
import swarm.simtoolsgui.GUISwarmImpl;

import swarm.space.Value2dDisplay;
import swarm.space.Value2dDisplayImpl;
import swarm.space.Object2dDisplay;
import swarm.space.Object2dDisplayImpl;

import java.util.List;

public final class ObserverSwarm extends GUISwarmImpl
{
	private static int displayFrequency;
	
	private static ActionGroup displayActions;				
  private static Schedule displaySchedule;
	
	private static ModelSwarm modelSwarm;
	
	private static Colormap colorMap;
	private static ZoomRaster worldRaster;
	
	private static Value2dDisplay foodDisplay;
	private static Object2dDisplay bugDisplay;
	
	public ObserverSwarm(Zone aZone)
	{
		super(aZone);
		displayFrequency = 1;
	}
	
	public Object buildObjects()
	{
		super.buildObjects();
		System.out.println("ObserverSwarm: super.buildObjects() finished\n");
		modelSwarm = new ModelSwarm (getZone());
		Globals.env.createArchivedProbeDisplay (modelSwarm, "modelSwarm");
    Globals.env.createArchivedProbeDisplay (this, "observerSwarm");	
		getControlPanel().setStateStopped();
		modelSwarm.buildObjects();
		System.out.println("ObserverSwarm: Setting colorMap\n");
		colorMap = new ColormapImpl(getZone());
		colorMap.setColor$ToName((byte)0, "black");
		colorMap.setColor$ToName((byte)1, "red");
		colorMap.setColor$ToName((byte)2, "green");
		System.out.println("ObserverSwarm: Setting worldRaster: running constructor\n");
		worldRaster = new ZoomRasterImpl(getZone(), "worldRaster");
		System.out.println("ObserverSwarm: Setting worldRaster: setColormap()\n");
		worldRaster.setColormap(colorMap);
		System.out.println("ObserverSwarm: Setting worldRaster: setZoomFactor\n");
		worldRaster.setZoomFactor(4);
		System.out.println("ObserverSwarm: Setting worldRaster: setWidth$Hight()\n");
		worldRaster.setWidth$Height(80, 80);
		System.out.println("ObserverSwarm: Setting worldRaster: setWindowTitle()\n");
		worldRaster.setWindowTitle("Food World");
		System.out.println("ObserverSwarm: Setting worldRaster: pack()\n");
		worldRaster.pack();
		System.out.println("ObserverSwarm: Setting foodDisplay\n");
		
		// foodDisplay = new Value2dDisplayImpl(getZone(), worldRaster, colorMap, modelSwarm.getFood());
		foodDisplay = new Value2dDisplayImpl();
		/*
		foodDisplay = new Value2dDisplayImpl();
		foodDisplay.setDisplayWidget$colormap(worldRaster, colorMap);
		foodDisplay.setDiscrete2dToDisplay(modelSwarm.getFood());
		*/
		System.out.println("ObserverSwarm: Setting bugDisplay\n");
		try 
		{
       /* bugDisplay = new Object2dDisplayImpl(getZone(), worldRaster, modelSwarm.getWorld(),
         new Selector(Class.forName("Bug"), "drawSelfOn", false)); */
					bugDisplay = new Object2dDisplayImpl();
    } catch (Exception e) 
		{
			System.out.println("ObserverSwarm: Exception handling bugDisplay\n");
    }
		
		/*
		bugDisplay = new Object2dDisplayImpl();
		bugDisplay.setDisplayWidget(worldRaster);
		bugDisplay.setDiscrete2dToDisplay(modelSwarm.getWorld());
		*/
		System.out.println("ObserverSwarm: Setting bugDisplay: setObjectCollection()\n");
		bugDisplay.setObjectCollection(modelSwarm.getBugList());
		// bugDisplay.setDisplayMessage("drawSelfOn:");
		
		
	
		return this;
	}
	
	public Object buildActions()
	{
		super.buildActions();
		modelSwarm.buildActions();
		displayActions = new ActionGroupImpl();
		try
		{
			displayActions.createActionTo$message(foodDisplay, new Selector(foodDisplay.getClass(), "display", false));
			displayActions.createActionTo$message(bugDisplay, new Selector(bugDisplay.getClass(), "display", false));
			displayActions.createActionTo$message(worldRaster, new Selector(worldRaster.getClass(), "drawSelf", false));
			// displayActions.createActionTo$message(actionCache, new Selector(actionCache.getClass(), "doTkEvents", false));
		}catch(Exception e)
		{
		}
		
		displaySchedule = new ScheduleImpl();
		displaySchedule.setRepeatInterval(displayFrequency);
		displaySchedule.at$createAction(0, displayActions);
		
		return this;
	}
	
	public Activity activateIn(Swarm swarmContext)
	{
		super.activateIn(swarmContext);
		modelSwarm.activateIn(this);
		displaySchedule.activateIn(this);
		return getActivity();
	}

}

